/////////////////////////////////////////////////////////////////////////////////
// copy this folder inside your gamestudio folder
// open physics2.wmp, build it and run it using physics2.wdl
/////////////////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600 pixels
var video_depth = 16; // 16 bit mode
var d3d_lightres = on;

var ent_number = 0;

/////////////////////////////////////////////////////////////////////////////////

bmap pointer_pcx = <pointer.pcx>;

/////////////////////////////////////////////////////////////////////////////////

string physics2_wmb = <physics2.wmb>;
string bullet_mdl = <bullet.mdl>;

/////////////////////////////////////////////////////////////////////////////////

sound beep_sound = <beep.wav>;

/////////////////////////////////////////////////////////////////////////////////

function fire_bullet();
function move_bullet();
function remove_bullet();

/////////////////////////////////////////////////////////////////////////////////

panel crosshair_pan 
{
	bmap = pointer_pcx;
	pos_x = 397;
	pos_y = 297;
	flags = visible, overlay;
}

/////////////////////////////////////////////////////////////////////////////////

function main()
{
	level_load (physics2_wmb);
}

starter multiple_objects()
{
	while (1)
	{
		ent_number = 1;
		wait (2);
		ent_number = 2;
		wait (2);
	}
}

action player1
{
	player = my;
	my.invisible = on; // hide the player model
	while (1)
	{
		vec_set (camera.pos, my.pos);
		camera.pan = my.pan;	
		camera.tilt += 10 * mouse_force.y * time;
		my.pan -= 10 * mouse_force.x * time;
		temp.x = 10 * (key_w - key_s) * time;
		temp.y = 5 * (key_a - key_d) * time;
		temp.z = 0;
		ent_move (temp, nullvector);
		wait (1);
	}
}

action physics_lamp
{
	my.unlit = on;
	my.ambient = 100;
	my.lightrange = 300;
	my.spotlight = on;
	vec_set (d3d_spotlightcone, vector (75, 30, 4));

	ph_setgravity (vector (0, 0, -386)); // gravity = 9.81 m/s2 if we agree to use 1 quant = 1 inch
	phent_settype (my, ph_rigid, ph_box);
	phent_setmass (my, 10, ph_box);
	phent_setdamping (my, 20, 50);
	my.skill20 = phcon_add (ph_ball, my, 0);
	phcon_setparams1 (my.skill20, vector (my.x, my.y, (my.z + 35)), nullvector, nullvector); // play with "35"
	while (1)
	{
		// return; // remove the comment if you own A6 professional (unlimited number of physics objects)
		if ((my.skill1 == 1) && (ent_number == 1))
		{
			phent_enable (my, 1);
		}
		if ((my.skill1 == 2) && (ent_number == 2))
		{
			phent_enable (my, 1);
		}
		wait (1);
		phent_enable (my, 0);
	}
}

function fire_bullet()
{
	ent_create (bullet_mdl, camera.x, move_bullet);
}

function move_bullet()
{
	my.unlit = on;
	my.enable_block = on; // the bullet is sensitive to level blocks
	my.enable_entity = on; // and entities
	my.enable_impact = on;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.event = remove_bullet;
	while(1)
	{
		if (vec_dist (my.x, camera.x) < 50)
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		temp.x = 30 * time;
		temp.y = 0;
		temp.z = 0;
		move_mode = ignore_you + ignore_passable + glide;
		ent_move (temp, nullvector);
		wait(1);
	}
}

function remove_bullet() 
{
	wait (1);
	ent_remove(me);
}

on_mouse_left = fire_bullet;